﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace FlatFileBDCModel.BdcModel1
{

    public class FlatFileEntityService
    {

        public static FlatFileEntity ReadItem(string id)
        {
            foreach (FlatFileEntity entity in GetAllEntities())
            {
                if (entity.ID == id)
                    return entity;
            }
            return null;
        }

        public static IEnumerable<FlatFileEntity> ReadList()
        {
            return GetAllEntities().ToArray();
        }

        public static List<FlatFileEntity> GetAllEntities()
        {
            List<FlatFileEntity> flatFileEntityList = new List<FlatFileEntity>();

            TextReader textReader = new StreamReader(@"c:\data\flat-file-data-source.txt");

            string row;

            while ((row = textReader.ReadLine()) != null)
            {
                FlatFileEntity flatFileEntity = new FlatFileEntity();

                string[] entityData = row.Split(',');

                flatFileEntity.ID = entityData[0];
                flatFileEntity.Company = entityData[1];
                flatFileEntity.FirstName = entityData[2];
                flatFileEntity.LastName = entityData[3];
                flatFileEntity.Address = entityData[4];
                flatFileEntity.City = entityData[5];
                flatFileEntity.State = entityData[6];
                flatFileEntity.ZipCode = entityData[7];
                flatFileEntity.Phone = entityData[8];
                flatFileEntity.LastUpdated = DateTime.Parse(entityData[9]);
                flatFileEntityList.Add(flatFileEntity);
            }

            textReader.Close();

            return flatFileEntityList;
        }
    }
}
